// ************************************************************************* //
//  File: BinnerGUIPluginInfo.C
// ************************************************************************* //

#include <BinnerPluginInfo.h>
#include <BinnerFilter.h>
#include <QvisBinnerWindow.h>

#if defined(__APPLE__)
#define GetGUIInfo Binner_GetGUIInfo
#endif

// ****************************************************************************
//  Function:  GetGUIInfo
//
//  Purpose:
//    Return a new GUIPluginInfo for the Binner operator.
//
//  Programmer: cristina -- generated by xml2info
//  Creation:   Thu Mar 30 12:05:26 PDT 2006
//
// ****************************************************************************
extern "C" GUIOperatorPluginInfo* GetGUIInfo()
{
    return new BinnerGUIPluginInfo;
}

// ****************************************************************************
//  Method: BinnerGUIPluginInfo::GetMenuName
//
//  Purpose:
//    Return a pointer to the name to use in the GUI menu.
//
//  Returns:    A pointer to the name to use in the GUI menu.
//
//  Programmer: cristina -- generated by xml2info
//  Creation:   Thu Mar 30 12:05:26 PDT 2006
//
// ****************************************************************************

const char *
BinnerGUIPluginInfo::GetMenuName() const
{
    return "Binner";
}


// ****************************************************************************
//  Method: BinnerGUIPluginInfo::CreatePluginWindow
//
//  Purpose:
//    Return a pointer to an operator's attribute window.
//
//  Arguments:
//    type      The type of the operator.
//    attr      The attribute subject for the operator.
//    notepad   The notepad to use for posting the window.
//
//  Returns:    A pointer to the operator's attribute window.
//
//  Programmer: cristina -- generated by xml2info
//  Creation:   Thu Mar 30 12:05:26 PDT 2006
//
// ****************************************************************************

QvisPostableWindowObserver *
BinnerGUIPluginInfo::CreatePluginWindow(int type, AttributeSubject *attr,
    QvisNotepadArea *notepad)
{
    return new QvisBinnerWindow(type, (Binner *)attr,
        "Binner operator attributes", "Binner operator", notepad);
}

// ****************************************************************************
//  Method: BinnerGUIPluginInfo::XPMIconData
//
//  Purpose:
//    Return a pointer to the icon data.
//
//  Returns:    A pointer to the icon data.
//
//  Programmer: cristina -- generated by xml2info
//  Creation:   Thu Mar 30 12:05:26 PDT 2006
//
// ****************************************************************************

#include <icon.xpm>
const char **
BinnerGUIPluginInfo::XPMIconData() const
{
    return icon_xpm;
}
