// ************************************************************************* //
//  File: BinnerPluginInfo.C
// ************************************************************************* //

#include <BinnerPluginInfo.h>
#include <BinnerFilter.h>

#include <visit-config.h>
#if defined(__APPLE__)
extern "C" const char *BinnerVisItPluginVersion = VERSION;
#else
extern "C" const char *VisItPluginVersion = VERSION;
#endif

#if defined(__APPLE__)
#define GetGeneralInfo Binner_GetGeneralInfo
#endif

// ****************************************************************************
//  Function:  GetGeneralInfo
//
//  Purpose:
//    Return a new GeneralPluginInfo for the Binner operator.
//
//  Programmer:  cristina -- generated by xml2info
//  Creation:    Thu Mar 30 12:05:26 PDT 2006
//
// ****************************************************************************
extern "C" GeneralOperatorPluginInfo* GetGeneralInfo()
{
    return new BinnerGeneralPluginInfo;
}

// ****************************************************************************
//  Method: BinnerGeneralPluginInfo::GetName
//
//  Purpose:
//    Return the name of the operator plugin.
//
//  Returns:    A pointer to the name of the operator plugin.
//
//  Programmer: cristina -- generated by xml2info
//  Creation:   Thu Mar 30 12:05:26 PDT 2006
//
// ****************************************************************************

char *
BinnerGeneralPluginInfo::GetName() const
{
    return "Binner";
}

// ****************************************************************************
//  Method: BinnerGeneralPluginInfo::GetVersion
//
//  Purpose:
//    Return the version of the operator plugin.
//
//  Returns:    A pointer to the version of the operator plugin.
//
//  Programmer: cristina -- generated by xml2info
//  Creation:   Thu Mar 30 12:05:26 PDT 2006
//
// ****************************************************************************

char *
BinnerGeneralPluginInfo::GetVersion() const
{
    return "1.0";
}

// ****************************************************************************
//  Method: BinnerGeneralPluginInfo::GetID
//
//  Purpose:
//    Return the id of the operator plugin.
//
//  Returns:    A pointer to the id of the operator plugin.
//
//  Programmer: cristina -- generated by xml2info
//  Creation:   Thu Mar 30 12:05:26 PDT 2006
//
// ****************************************************************************

char *
BinnerGeneralPluginInfo::GetID() const
{
    return "Binner_1.0";
}
// ****************************************************************************
//  Method: BinnerGeneralPluginInfo::EnabledByDefault
//
//  Purpose:
//    Return true if this plugin should be enabled by default; false otherwise.
//
//  Returns:    true/false
//
//  Programmer: cristina -- generated by xml2info
//  Creation:   Thu Mar 30 12:05:26 PDT 2006
//
// ****************************************************************************

bool
BinnerGeneralPluginInfo::EnabledByDefault() const
{
    return true;
}
